## multipath-tools 0.8.3

=== multipathd/Makefile ===
include ../Makefile.inc

#
# debugging stuff
#
#CFLAGS += -DLCKDBG
#CFLAGS += -D_DEBUG_
#CFLAGS += -DLOGDBG
CFLAGS += $(BIN_CFLAGS) -I$(multipathdir) -I$(mpathpersistdir) \
	  -I$(mpathcmddir) -I$(thirdpartydir)
LDFLAGS += $(BIN_LDFLAGS)
LIBDEPS += -L$(multipathdir) -lmultipath -L$(mpathpersistdir) -lmpathpersist \
	   -L$(mpathcmddir) -lmpathcmd -ludev -ldl -lurcu -lpthread \
	   -ldevmapper -lreadline

ifdef SYSTEMD
	CFLAGS += -DUSE_SYSTEMD=$(SYSTEMD)
	ifeq ($(shell test $(SYSTEMD) -gt 209 && echo 1), 1)
		LIBDEPS += -lsystemd
	else
		LIBDEPS += -lsystemd-daemon
	endif
endif
ifeq ($(ENABLE_DMEVENTS_POLL),0)
	CFLAGS += -DNO_DMEVENTS_POLL
endif

OBJS = main.o pidfile.o uxlsnr.o uxclnt.o cli.o cli_handlers.o waiter.o \
       dmevents.o

EXEC = multipathd

all : $(EXEC)

$(EXEC): $(OBJS) $(multipathdir)/libmultipath.so $(mpathcmddir)/libmpathcmd.so
	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) -o $(EXEC) $(LIBDEPS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
ifdef SYSTEMD
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(unitdir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).service $(DESTDIR)$(unitdir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).socket $(DESTDIR)$(unitdir)
endif
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(man8dir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(man8dir)

uninstall:
	$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(RM) $(DESTDIR)$(man8dir)/$(EXEC).8.gz
	$(RM) $(DESTDIR)$(unitdir)/$(EXEC).service
	$(RM) $(DESTDIR)$(unitdir)/$(EXEC).socket

clean: dep_clean
	$(RM) core *.o $(EXEC) *.gz

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(RM) $(OBJS:.o=.d)

=== libmultipath/checkers/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../../Makefile.inc

CFLAGS += $(LIB_CFLAGS) -I..

# If you add or remove a checker also update multipath/multipath.conf.5
LIBS= \
	libcheckcciss_tur.so \
	libcheckreadsector0.so \
	libchecktur.so \
	libcheckdirectio.so \
	libcheckemc_clariion.so \
	libcheckhp_sw.so \
	libcheckrdac.so

all: $(LIBS)

libcheckdirectio.so: libsg.o directio.o
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^ -laio

libcheck%.so: libsg.o %.o
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^

install:
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(libdir)

uninstall:
	for file in $(LIBS); do $(RM) $(DESTDIR)$(libdir)/$$file; done

clean: dep_clean
	$(RM) core *.a *.o *.gz *.so

OBJS := $(LIBS:libcheck%.so=%.o) libsg.o directio.o
.SECONDARY: $(OBJS)

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(RM) $(OBJS:.o=.d)

=== libmultipath/prioritizers/Makefile ===
#
# Copyright (C) 2007 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../../Makefile.inc

CFLAGS += $(LIB_CFLAGS) -I..

# If you add or remove a prioritizer also update multipath/multipath.conf.5
LIBS = \
	libprioalua.so \
	libprioconst.so \
	libpriodatacore.so \
	libprioemc.so \
	libpriohds.so \
	libpriohp_sw.so \
	libprioiet.so \
	libprioontap.so \
	libpriorandom.so \
	libpriordac.so \
	libprioweightedpath.so \
	libpriopath_latency.so \
	libpriosysfs.so

ifneq ($(call check_file,/usr/include/linux/nvme_ioctl.h),0)
	LIBS += libprioana.so
	CFLAGS += -I../nvme
endif

all: $(LIBS)

libpriopath_latency.so: path_latency.o  ../checkers/libsg.o
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^ -lm

libprio%.so: %.o
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^

install: $(LIBS)
	$(INSTALL_PROGRAM) -m 755 libprio*.so $(DESTDIR)$(libdir)

uninstall:
	for file in $(LIBS); do $(RM) $(DESTDIR)$(libdir)/$$file; done

clean: dep_clean
	$(RM) core *.a *.o *.gz *.so

OBJS = $(LIBS:libprio%.so=%.o) alua_rtpg.o
.SECONDARY: $(OBJS)

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(RM) $(OBJS:.o=.d)

=== debian/changelog ===
multipath-tools (0.8.3-1ubuntu2.4) focal; urgency=medium

  * Use Debian-specific partx path in kpartx rule (LP: #2064201)
    - d/p/lp2064201-kpartx-rules-use-Debian-specific-partx-path.patch

 -- Chengen Du <chengen.du@canonical.com>  Tue, 30 Apr 2024 07:49:10 +0000

multipath-tools (0.8.3-1ubuntu2.3) focal; urgency=medium

  [ Jorge Merlino ]
  * Multipath devices not removed with high load (LP: #2039719)
    - d/p/lp2039719-1-libmultipath-make-dm_get_map-status-return-codes-sym.patch:
      change the return value of some functions from a boolean to symbolic codes 
      to differentiate errors
    - d/p/lp2039719-2-multipathd-fix-check_path-errors-with-removed-map.patch:
      use the new error codes to change the error processing on the 
      check_path() procedure

  [ Mauricio Faria de Oliveira ]
  * Add upstream fixes:
    - d/p/lp2039719-3-multipathd-fix-NULL-dereference-in-check_path.patch
    - d/p/lp2042366-dm_get_map-fix-segfault-when-can-t-found-target.patch
      (LP: #2042366)

 -- Jorge Merlino <jorge.merlino@canonical.com>  Tue, 07 Nov 2023 18:20:27 -0300

multipath-tools (0.8.3-1ubuntu2.2) focal; urgency=medium

  * Do not install init scripts (LP: #2000186)
    - d/multipath-tools.maintscript: remove /etc/init.d/multipath-tools
    - d/rules: do not call dh_installinit

 -- Mitchell Dzurick <mitchell.dzurick@canonical.com>  Mon, 24 Jul 2023 16:06:36 -0700

multipath-tools (0.8.3-1ubuntu2.1) focal-security; urgency=medium

  * SECURITY UPDATE: symlink attack
    - debian/patches/CVE-2022-41973.patch: use /run instead of /dev/shm in
      .gitignore, Makefile.inc, libmultipath/defaults.h,
      multipath/Makefile, multipath/multipath.rules.in,
      multipath/tmpfiles.conf.in.
    - debian/multipath-tools.install, debian/multipath-udeb.install:
      install tmpfiles.d/multipath.conf.
    - debian/rules: copy udev rule after build.
    - CVE-2022-41973
  * SECURITY UPDATE: authorization bypass
    - debian/patches/CVE-2022-41974.patch: ignore duplicated multipathd
      command keys in multipathd/main.c, multipathd/cli.c.
    - CVE-2022-41974

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 31 Oct 2022 11:14:23 -0400

multipath-tools (0.8.3-1ubuntu2) focal; urgency=medium

  * Enable udebs on riscv64 to fix FTBFS.

 -- William Grant <wgrant@ubuntu.com>  Mon, 06 Apr 2020 18:17:20 +1000

multipath-tools (0.8.3-1ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Stop producing udebs on i386 where we no longer have d-i or a kernel.
    - Fix debian/rules to not explode when building without udebs on i386.
    - Don't build the multipath-tools binary package on i386; we only want
      kpartx.
    - d/control:
      - multipath-udeb: add sg3-udeb Depends
    - d/rules: Move udev rules to priority 95, because rules that load modules
      should be >90.
    - d/multipath-tools.preinst: modprobe dm-multipath; This will make sure
      that multipathd will be able to start.
    - Split kpartx initramfs bits into kpartx-boot for dmraid (LP 941874)
      - d/initramfs/kpartx.hook
      - d/kpartx-boot.postinst
      - d/kpartx-boot.postrm
      - d/control: Add kpartx-boot package for dmraid
      - d/rules: Install kpartx initramfs hook
      - d/kpartx.install: install all arch /lib* kpartx udev rules
    - patches to multipath source
      - d/p/1000--set-umask-in-multipathd.patch: Set umask in multipathd.
      - d/p/kpartx_more_loopback_fixes.patch: fix loopback mounted
        files some more: since we stat() the loopback device node, we can't rely
        on S_ISREG() tests to handle this case, and should look at the device
        itself instead. (LP 1543430)
      - d/p/enable-find-multipaths.patch: re-enable find_multipaths
        by default -- see the removed 'add_find-multipaths.patch' (LP 1463046)
   - multipath initramfs fixes for booting from multipathed devices
      - d/initramfs/hooks: also copy wwids file on the installed system to
        ensure all paths come up on boot. (LP 1479929)
      - d/initramfs/hooks: install multipathd and required directories.
      - d/initramfs/hooks: copy multipath udev rules to initramfs
      - d/initramfs/hooks: do not copy kpartx rules to initramfs
      - d/initramfs/local-bottom: remember to stop multipathd.
      - d/initramfs/local-premount: wait for udev to settle before the call to
        resolve_device() in local_mount_root(), so the by-uuid/ symlinks have a
        chance to be updated by the multipath udev rules (LP 1503286).
      - d/initramfs/local-premount: Run multipath with -B so not to assign names
        nor change /etc/multipath/bindings during initramfs (LP 1561103)
      - d/rules: install d/initramfs/local-bottom
      - d/rules: install d/initramfs/local-premount
   - Disable -fexceptions on multipath-udeb (LP 1489379): the flag causes
     libchecktur.so to link with libgcc_s.so.1 (even with -static-libgcc),
     which is not available in the installer environment.
     - d/p/disable-fexceptions-udeb.patch: conditionally disable -fexceptions
       with CFLAGS_DISABLE_FEXCEPTIONS.
     - d/rules: set CFLAGS_DISABLE_FEXCEPTIONS to build multipath-udeb.
   - Remove d/initramfs/local-top (redundant with other initramfs scripts):
     - init-top: take over loading modules (dm-multipath and SCSI device
       handlers); move the missing dm-emc there (now scsi-dh-emc;
       see BTS 567014).
     - d/rules: do not install local-top anymore.
     - remove d/initramfs/local-top
    - Fixes typo in package description (availibility -> availability)
      (LP 1231182)
    - debian/initramfs/local-bottom: wait for the multipathd unix socket
      to close, so to avoid multipathd.socket unit failure. (LP 1682178)
    - debian/initramfs/hooks: Add dm-queue-length: users may want to change
      from the default selector and should be able to do so. (LP 1673350)
    - d/p/kpartx-Improve-finding-loopback-device-by-file.patch: Improve


=== debian/control ===
Source: multipath-tools
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian DM Multipath Team <team+linux-blocks@tracker.debian.org>
Uploaders: Guido Günther <agx@sigxcpu.org>, Ritesh Raj Sarraf <rrs@debian.org>, Chris Hofstaedtler <zeha@debian.org>
Build-Depends: debhelper (>= 9.20160709), po-debconf, libdevmapper-dev (>= 2:1.02.20), libreadline-dev, libaio-dev, dpkg-dev (>= 1.16.1~), libudev-dev, libsystemd-dev, systemd, liburcu-dev, pkg-config, libjson-c-dev
Vcs-Git: https://salsa.debian.org/linux-blocks-team/multipath-tools.git
Vcs-Browser: https://salsa.debian.org/linux-blocks-team/multipath-tools
Standards-Version: 3.9.8
Homepage: http://christophe.varoqui.free.fr/

Package: multipath-tools
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 136-1), kpartx (>= ${binary:Version}), lsb-base (>= 3.0-6), libaio1 (>= 0.3.106-8), sg3-utils-udev
Breaks: multipath-tools-initramfs (<= 1.0.1),
 multipath-tools-boot (<= 0.4.8+git0.761c66f-2~)
Suggests: multipath-tools-boot
Description: maintain multipath block device access
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.
 .
 If you install this package you may have to change the way you address block
 devices. See README.Debian for details.

Package: kpartx
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 136-1), dmsetup (>= 2:1.02.24)
Replaces: multipath-tools (<< 0.4.7-3)
Description: create device mappings for partitions
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

Package: kpartx-boot
Architecture: all
Depends: ${misc:Depends}, initramfs-tools,
 kpartx (>= ${source:Version}), kpartx (<< ${source:Version}.1~)
Description: Provides kpartx during boot
 This package makes kpartx available during boot to activate partitions

Package: multipath-tools-boot
Architecture: all
Depends: ${misc:Depends}, initramfs-tools | linux-initramfs-tool, lsb-base (>= 3.0-6),
 multipath-tools (>= ${source:Version}), multipath-tools (<< ${source:Version}.1~),
 kpartx-boot (= ${binary:Version})
Replaces: multipath-tools-initramfs (<< 1.0.1+nmu1), multipath-tools (<< 0.5.0+git1.656f8865-6)
Breaks: multipath-tools-initramfs (<< 1.0.1+nmu1), multipath-tools (<< 0.5.0+git1.656f8865-6)
Description: Support booting from multipath devices
 This package contains the necessary support for booting from a multipath
 device:
 .
  * copy over multipath.conf and persistent bindings if necessary
  * load the necessary kernel modules
  * detect multipath block devices
 .
 Don't install this package if you're not booting from a multipath device.

Package: multipath-udeb
Package-Type: udeb
Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}, multipath-modules, kpartx-udeb, sg3-udeb
Section: debian-installer
Description: maintain multipath block device access - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.

Package: kpartx-udeb
Package-Type: udeb
Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: debian-installer
Description: create device mappings for partitions - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

=== debian/rules ===
#!/usr/bin/make -f

INITRAMFS=$(CURDIR)/debian/multipath-tools-boot/usr/share/initramfs-tools/

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
        INSTALL_PROGRAM = install -s
else
        INSTALL_PROGRAM = install
endif

ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH),i386)
        ADD_UDEB = --no-add-udeb
	skip_packages = -Nmultipath-tools
else
        ADD_UDEB = --add-udeb=multipath-udeb
endif

# For Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
export KBUILD_BUILD_TIMESTAMP = "@$(SOURCE_DATE_EPOCH)"
#

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-arch build-indep

build-arch: build-multipath-udeb-stamp build-stamp
build-indep:
	# Nothing to do here.
	touch $@

build-stamp: clean-tree
	dh_testdir
	
	[ ! -f kpartx/del-part-nodes.rules ] || cp kpartx/del-part-nodes.rules debian/kpartx.del-part-nodes.udev
	[ ! -f kpartx/dm-parts.rules ] || cp kpartx/dm-parts.rules debian/kpartx.dm-parts.udev
	[ ! -f kpartx/kpartx.rules ] || cp kpartx/kpartx.rules debian/kpartx.udev
	[ ! -f multipath/11-dm-mpath.rules ] || cp multipath/11-dm-mpath.rules debian/dm-mpath.udev

	dh_auto_build -- $(OPTFLAGS) LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1

	[ ! -f multipath/multipath.rules ] || cp multipath/multipath.rules debian/multipath.udev

	touch $@

# multipath-udeb: build separately; don't reference dynamic libgcc at runtime (#779579)
build-multipath-udeb-stamp:
	dh_testdir

	DEB_CFLAGS_MAINT_APPEND="-static-libgcc" CFLAGS_DISABLE_FEXCEPTIONS=1 dh_auto_build -- $(OPTFLAGS) LIB=/lib USE_SYSTEMD=0
	
	# store files for install target
	mkdir -p $(CURDIR)/debian/tmp-multipath-udeb/sbin
	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp-multipath-udeb LIB=/lib USE_SYSTEMD=0

	touch $@

clean-tree:
	$(MAKE) clean

clean: clean-tree
	dh_testdir
	rm -f build-stamp build-multipath-udeb-stamp
	dh_prep
	debconf-updatepo
	rm -rf debian/*.debhelper.log
	rm -rf debian/tmp-multipath-udeb
	dh_clean

install-indep:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# initramfs stuff:
	install -D -m 755 debian/initramfs/hooks $(INITRAMFS)/hooks/multipath
	install -D -m 755 debian/initramfs/kpartx.hook $(CURDIR)/debian/kpartx-boot/usr/share/initramfs-tools/hooks/kpartx
	install -D -m 755 debian/initramfs/local-premount \
		$(INITRAMFS)/scripts/local-premount/multipath
	install -D -m 755 debian/initramfs/local-bottom \
		$(INITRAMFS)/scripts/local-bottom/multipath
	install -D -m 755 debian/initramfs/init-top \
		$(INITRAMFS)/scripts/init-top/multipath

	# reportbug:
	for pkg in "multipath-tools" "multipath-tools-boot"; do \
	    install -D -m 755 debian/reportbug/script debian/$${pkg}/usr/share/bug/$${pkg}/script; \
	done

	# lintian override
	install -D -m 644 debian/multipath-tools-boot.lintian-overrides \
	    debian/multipath-tools-boot/usr/share/lintian/overrides/multipath-tools-boot


install: install-indep
	dh_testdir
	dh_testroot
	dh_installdirs

	mkdir -p $(CURDIR)/debian/tmp/sbin
	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1
	install -m 755 debian/dmsetup_env $(CURDIR)/debian/tmp/lib/udev/
	mkdir -p $(CURDIR)/debian/tmp/etc
	cp debian/multipath.conf $(CURDIR)/debian/tmp/etc
	dh_install -X.rules --fail-missing -Nmultipath-udeb --sourcedir=$(CURDIR)/debian/tmp
	dh_install -Xkpartx_id -X.rules -X.service -X.socket --fail-missing -pmultipath-udeb --sourcedir=$(CURDIR)/debian/tmp-multipath-udeb

binary-indep: build-indep install-indep
	dh_testdir -i
	dh_testroot -i
	dh_installdirs -i
	dh_installchangelogs -i
	dh_installdocs -i
	dh_installexamples -i
	dh_installdebconf -pmultipath-tools-boot
	dh_installman -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installexamples -a
	dh_lintian -a
	dh_systemd_enable -pmultipath-tools multipathd.service
	dh_installudev -pkpartx --priority=95
	dh_installudev -pkpartx --name=dm-parts --priority=56
	dh_installudev -pkpartx --name=del-part-nodes --priority=68
	dh_installudev -pmultipath-tools --name=multipath
	dh_installudev -pmultipath-tools --name=dm-mpath --priority=56
	dh_link -a lib/systemd/system/multipathd.service \
		lib/systemd/system/multipath-tools.service
	dh_systemd_start -pmultipath-tools multipathd.service
	dh_installman -a
	dh_makeshlibs -a $(ADD_UDEB)
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a $(skip_packages)
	dh_md5sums -a
	dh_builddeb -a $(skip_packages)

binary:	binary-indep binary-arch
.PHONY: binary binary-arch binary-indep unpack configure build clean

=== debian/tests/control ===

Tests: kpartx-file-loopback
Depends: kpartx, qemu-utils, gdisk
Restrictions: needs-root, isolation-machine

Tests: tgtbasedmpaths
Depends: multipath-tools, tgt, open-iscsi, fio, lsscsi
Restrictions: needs-root, isolation-machine, allow-stderr

## multipath-tools 0.8.4

=== debian/changelog ===
multipath-tools (0.8.4-4ubuntu2) groovy; urgency=medium

  * Add README.alua to docs section

 -- Rafael David Tinoco <rafaeldtinoco@ubuntu.com>  Fri, 11 Sep 2020 17:39:12 +0000

multipath-tools (0.8.4-4ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - multipath initramfs fixes for booting from multipathed devices:
      - d/initramfs/hooks: also copy wwids file on the installed
        system to ensure all paths come up on boot. (LP 1479929)
      - d/initramfs/hooks: install multipathd and required
        directories.
      - d/initramfs/hooks: copy multipath udev rules to initramfs
      - d/initramfs/hooks: do not copy kpartx rules to initramfs
      - d/initramfs/local-bottom: remember to stop multipathd.
      - d/initramfs/local-premount: wait for udev to settle before
        the call to resolve_device() in local_mount_root(), so the
        by-uuid/ symlinks have a chance to be updated by the
        multipath udev rules (LP 1503286).
      - d/initramfs/local-premount: Run multipath with -B so not to
        assign names nor change /etc/multipath/bindings during
        initramfs (LP 1561103)
      - d/rules: install d/initramfs/local-bottom
      - d/rules: install d/initramfs/local-premount
    - d/control: multipath-udeb: add sg3-udeb Depends
    - patches to multipath source:
      - d/p/kpartx_more_loopback_fixes.patch: fix loopback mounted files
        some more: since we stat() the loopback device node, we can't rely
        on S_ISREG() tests to handle this case, and should look at the
        device itself instead. (LP 1543430)
      - d/p/enable-find-multipaths.patch: re-enable find_multipaths by
        default -- see the removed 'add_find-multipaths.patch' (LP 1463046)
    - Split kpartx initramfs bits into kpartx-boot for dmraid (LP 941874)
      - d/initramfs/kpartx.hook
      - d/kpartx-boot.postinst
      - d/kpartx-boot.postrm
      - d/control: Add kpartx-boot package for dmraid
      - d/rules: Install kpartx initramfs hook
      - d/kpartx.install: install all arch /lib* kpartx udev rules
    - debian/multipath-tools.dm-mpath-lvm.udev: Adjust initramfs integration
      for new udev rules
    - Remove d/initramfs/local-top (redundant with other initramfs scripts):
      - init-top: take over loading modules (dm-multipath and SCSI device
        handlers); move the missing dm-emc there (now scsi-dh-emc; see
        BTS 567014).
      - d/rules: do not install local-top anymore.
      - remove d/initramfs/local-top
    - d/control: Enable udebs on riscv64 to fix FTBFS.
    - d/control, d/rules: i386 related fixes
      - Stop producing udebs on i386 where we no longer have d-i or a kernel.
      - Fix debian/rules to not explode when building without udebs on i386.
      - Don't build the multipath-tools binary package on i386; we only want
        kpartx.
    - Disable -fexceptions on multipath-udeb (LP 1489379): the flag causes
      libchecktur.so to link with libgcc_s.so.1 (even with -static-libgcc),
      which is not available in the installer environment.
      - d/p/disable-fexceptions-udeb.patch: conditionally disable
        -fexceptions with CFLAGS_DISABLE_FEXCEPTIONS.
      - d/rules: set CFLAGS_DISABLE_FEXCEPTIONS to build multipath-udeb.
    - d/p/kpartx-print-loop-deleted-to-stdout-not-stderr.patch: Print loop
      deleted message to stdout again, not stderr; to fix autopkgtest
    - d/multipath.conf: Install friendly names multipath.conf by default,
      instead of generating it in every installer.
    - d/rules: Move udev rules to priority 95, because rules that load
      modules should be >90.
    - d/p/no-start-in-containers.patch: Do not attempt to start
      multipath-tools in containers, should switch for on-demand udev/socket
      based activation in the future. (LP 1823093)
    - d/p/kpartx-Improve-finding-loopback-device-by-file.patch: Improve
      finding loopback devices (LP 1747044)
    - debian/initramfs/hooks: Add dm-queue-length: users may want to
      change from the default selector and should be able to do so.
      (LP 1673350)
    - debian/initramfs/local-bottom: wait for the multipathd unix
      socket to close, so to avoid multipathd.socket unit failure.
      (LP 1682178)
    - debian/tests/tgtbasedmpaths:
      - Add sleep to allow for device creation
      - Use stable wwn-* names in autopkgtest that work with or without
        friendly names, as scsi-${DM_NAME} is not a stable symlink name.
  * Dropped changes, superseeded by systemd switch to service script:
    - d/multipath-tools.preinst: modprobe dm-multipath; This will make
      sure that multipathd will be able to start.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 31 Aug 2020 00:12:32 +0200

multipath-tools (0.8.4-4) unstable; urgency=medium

  * [637efc8] Remove overly complicated INSTALL_PROGRAM setup.
    Thanks to Simon McVittie <smcv@debian.org> (Closes: #968528)
  * [d793f77] kpartx, multipath-tools: remove pre-oldstable upgrade code
  * [aa2fab9] d/*: trim trailing whitespace
  * [1657612] multipath-tools, multipath-tools-boot: update lintian overrides
  * [825c1e2] debian/po/de.po: recode to UTF-8
  * [ce008ac] Allow (partial) parallel builds
  * [6383d2d] d/control: remove relationships satisfied in oldstable
  * [bf0e585] d/control: remove version constraints satisfied in oldstable
  * [67cff60] Declare debhelper compat version using debhelper-compat
  * [6992798] Apply to-be-upstream patch for parallel builds.
    Thanks to Christian Hesse <mail@eworm.de>
  * [058d79f] Use to-be-upstream patch for json-c update

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 30 Aug 2020 01:14:10 +0000

multipath-tools (0.8.4-3ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - multipath initramfs fixes for booting from multipathed devices:
      - d/initramfs/hooks: also copy wwids file on the installed
        system to ensure all paths come up on boot. (LP 1479929)


=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian DM Multipath Team <team+linux-blocks@tracker.debian.org>
 Uploaders: Guido Günther <agx@sigxcpu.org>, Ritesh Raj Sarraf <rrs@debian.org>, Chris Hofstaedtler <zeha@debian.org>
-Build-Depends: debhelper (>= 9.20160709), po-debconf, libdevmapper-dev (>= 2:1.02.20), libreadline-dev, libaio-dev, dpkg-dev (>= 1.16.1~), libudev-dev, libsystemd-dev, systemd, liburcu-dev, pkg-config, libjson-c-dev
+Build-Depends: debhelper-compat (= 9), po-debconf, libdevmapper-dev, libreadline-dev, libaio-dev, libudev-dev, libsystemd-dev, systemd, liburcu-dev, pkg-config, libjson-c-dev
 Vcs-Git: https://salsa.debian.org/linux-blocks-team/multipath-tools.git
 Vcs-Browser: https://salsa.debian.org/linux-blocks-team/multipath-tools
 Standards-Version: 3.9.8
@@ -12,9 +12,7 @@
 
 Package: multipath-tools
 Architecture: linux-any
-Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 136-1), kpartx (>= ${binary:Version}), lsb-base (>= 3.0-6), libaio1 (>= 0.3.106-8), sg3-utils-udev
-Breaks: multipath-tools-initramfs (<= 1.0.1),
- multipath-tools-boot (<= 0.4.8+git0.761c66f-2~)
+Depends: ${shlibs:Depends}, ${misc:Depends}, udev, kpartx (>= ${binary:Version}), lsb-base, libaio1, sg3-utils-udev
 Suggests: multipath-tools-boot
 Description: maintain multipath block device access
  These tools are in charge of maintaining the disk multipath device maps and
@@ -25,8 +23,7 @@
 
 Package: kpartx
 Architecture: linux-any
-Depends: ${shlibs:Depends}, ${misc:Depends}, udev (>> 136-1), dmsetup (>= 2:1.02.24)
-Replaces: multipath-tools (<< 0.4.7-3)
+Depends: ${shlibs:Depends}, ${misc:Depends}, udev, dmsetup
 Description: create device mappings for partitions
  Kpartx can be used to set up device mappings for the partitions of any
  partitioned block device. It is part of the Linux multipath-tools.
@@ -40,11 +37,9 @@
 
 Package: multipath-tools-boot
 Architecture: all
-Depends: ${misc:Depends}, initramfs-tools | linux-initramfs-tool, lsb-base (>= 3.0-6),
+Depends: ${misc:Depends}, initramfs-tools | linux-initramfs-tool, lsb-base,
  multipath-tools (>= ${source:Version}), multipath-tools (<< ${source:Version}.1~),
  kpartx-boot (= ${binary:Version})
-Replaces: multipath-tools-initramfs (<< 1.0.1+nmu1), multipath-tools (<< 0.5.0+git1.656f8865-6)
-Breaks: multipath-tools-initramfs (<< 1.0.1+nmu1), multipath-tools (<< 0.5.0+git1.656f8865-6)
 Description: Support booting from multipath devices
  This package contains the necessary support for booting from a multipath
  device:
@@ -76,4 +71,3 @@
  .
  Kpartx can be used to set up device mappings for the partitions of any
  partitioned block device. It is part of the Linux multipath-tools.
-

## multipath-tools 0.8.5

=== Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#

BUILDDIRS := \
	libmpathcmd \
	libmultipath \
	libmultipath/prioritizers \
	libmultipath/checkers \
	libmultipath/foreign \
	libmpathpersist \
	multipath \
	multipathd \
	mpathpersist \
	kpartx

ifneq ($(ENABLE_LIBDMMP),0)
BUILDDIRS += \
	libdmmp
endif

BUILDDIRS.clean := $(BUILDDIRS:=.clean) tests.clean

.PHONY:	$(BUILDDIRS) $(BUILDDIRS:=.uninstall) $(BUILDDIRS:=.install) $(BUILDDIRS.clean)

all:	$(BUILDDIRS)

$(BUILDDIRS):
	$(MAKE) -C $@

libmultipath libdmmp: libmpathcmd
libmpathpersist multipath multipathd: libmultipath
mpathpersist multipathd:  libmpathpersist

libmultipath/checkers.install \
	libmultipath/prioritizers.install \
	libmultipath/foreign.install: libmultipath.install

$(BUILDDIRS.clean):
	$(MAKE) -C ${@:.clean=} clean

$(BUILDDIRS:=.install):
	$(MAKE) -C ${@:.install=} install

$(BUILDDIRS:=.uninstall):
	$(MAKE) -C ${@:.uninstall=} uninstall

clean: $(BUILDDIRS.clean)
install: $(BUILDDIRS:=.install)
uninstall: $(BUILDDIRS:=.uninstall)

test:	all
	$(MAKE) -C tests

valgrind-test:	all
	$(MAKE) -C tests valgrind

.PHONY:	TAGS
TAGS:
	etags -a libmultipath/*.c
	etags -a libmultipath/*.h
	etags -a multipathd/*.c
	etags -a multipathd/*.h

=== libmultipath/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

SONAME = 0
DEVLIB = libmultipath.so
LIBS = $(DEVLIB).$(SONAME)

CFLAGS += $(LIB_CFLAGS) -I$(mpathcmddir) -I$(mpathpersistdir) -I$(nvmedir)

LIBDEPS += -lpthread -ldl -ldevmapper -ludev -L$(mpathcmddir) -lmpathcmd -lurcu -laio

ifdef SYSTEMD
	CFLAGS += -DUSE_SYSTEMD=$(SYSTEMD)
	ifeq ($(shell test $(SYSTEMD) -gt 209 && echo 1), 1)
		LIBDEPS += -lsystemd
	else
		LIBDEPS += -lsystemd-daemon
	endif
endif

ifneq ($(call check_func,dm_task_no_flush,/usr/include/libdevmapper.h),0)
	CFLAGS += -DLIBDM_API_FLUSH -D_GNU_SOURCE
endif

ifneq ($(call check_func,dm_task_get_errno,/usr/include/libdevmapper.h),0)
	CFLAGS += -DLIBDM_API_GET_ERRNO
endif

ifneq ($(call check_func,dm_task_set_cookie,/usr/include/libdevmapper.h),0)
	CFLAGS += -DLIBDM_API_COOKIE
endif

ifneq ($(call check_func,udev_monitor_set_receive_buffer_size,/usr/include/libudev.h),0)
	CFLAGS += -DLIBUDEV_API_RECVBUF
endif

ifneq ($(call check_func,dm_task_deferred_remove,/usr/include/libdevmapper.h),0)
	CFLAGS += -DLIBDM_API_DEFERRED
endif

ifneq ($(call check_func,dm_hold_control_dev,/usr/include/libdevmapper.h),0)
	CFLAGS += -DLIBDM_API_HOLD_CONTROL
endif

OBJS = memory.o parser.o vector.o devmapper.o callout.o \
	hwtable.o blacklist.o util.o dmparser.o config.o \
	structs.o discovery.o propsel.o dict.o \
	pgpolicies.o debug.o defaults.o uevent.o time-util.o \
	switchgroup.o uxsock.o print.o alias.o log_pthread.o \
	log.o configure.o structs_vec.o sysfs.o prio.o checkers.o \
	lock.o file.o wwids.o prioritizers/alua_rtpg.o prkey.o \
	io_err_stat.o dm-generic.o generic.o foreign.o nvme-lib.o \
	libsg.o valid.o

all: $(LIBS)

nvme-lib.o: nvme-lib.c nvme-ioctl.c nvme-ioctl.h
	$(CC) $(CFLAGS) -Wno-unused-function -c -o $@ $<

# there are lots of "unused parameters" in dict.c
# because not all handler / snprint methods nees all parameters
dict.o:	dict.c
	$(CC) $(CFLAGS) -Wno-unused-parameter -c -o $@ $<

make_static = $(shell sed '/^static/!s/^\([a-z]\{1,\} \)/static \1/' <$1 >$2)

nvme-ioctl.c: nvme/nvme-ioctl.c
	$(call make_static,$<,$@)

nvme-ioctl.h: nvme/nvme-ioctl.h
	$(call make_static,$<,$@)

$(LIBS): $(OBJS)
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -Wl,-soname=$@ -o $@ $(OBJS) $(LIBDEPS)
	$(LN) $@ $(DEVLIB)

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(syslibdir)
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(libdir)
	$(LN) $(LIBS) $(DESTDIR)$(syslibdir)/$(DEVLIB)

uninstall:
	$(RM) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(RM) $(DESTDIR)$(syslibdir)/$(DEVLIB)

clean: dep_clean
	$(RM) core *.a *.o *.so *.so.* *.gz nvme-ioctl.c nvme-ioctl.h

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(RM) $(OBJS:.o=.d)

=== multipathd/Makefile ===
--- 
+++ 
@@ -1,4 +1,8 @@
 include ../Makefile.inc
+
+ifneq ($(call check_func,dm_task_get_errno,/usr/include/libdevmapper.h),0)
+	CFLAGS += -DLIBDM_API_GET_ERRNO
+endif
 
 #
 # debugging stuff
@@ -36,6 +40,9 @@
 	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) -o $(EXEC) $(LIBDEPS)
 	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
 
+cli_handlers.o:	cli_handlers.c
+	$(CC) $(CFLAGS) -Wno-unused-parameter -c -o $@ $<
+
 install:
 	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
 	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)

=== tests/Makefile ===
include ../Makefile.inc

# Test special behavior of gcc 4.8 with nested initializers
# gcc 4.8 compiles blacklist.c only with -Wno-missing-field-initializers
TEST_MISSING_INITIALIZERS = $(shell \
	echo 'struct A {int a, b;}; struct B {struct A a; int b;} b = {.a.a=1};' | \
		$(CC) -c -Werror -Wmissing-field-initializers -o /dev/null -xc - >/dev/null 2>&1 \
	|| echo -Wno-missing-field-initializers)
W_MISSING_INITIALIZERS := $(call TEST_MISSING_INITIALIZERS)

CFLAGS += $(BIN_CFLAGS) -I$(multipathdir) -I$(mpathcmddir) \
	-Wno-unused-parameter $(W_MISSING_INITIALIZERS)
LIBDEPS += -L$(multipathdir) -L$(mpathcmddir) -lmultipath -lmpathcmd -lcmocka

TESTS := uevent parser util dmevents hwtable blacklist unaligned vpd pgpolicy \
	 alias directio valid devt
HELPERS := test-lib.o test-log.o

.SILENT: $(TESTS:%=%.o)
.PRECIOUS: $(TESTS:%=%-test)

all:	$(TESTS:%=%.out)
valgrind:	$(TESTS:%=%.vgr)

# test-specific compiler flags
# XYZ-test_FLAGS: Additional compiler flags for this test

ifneq ($(wildcard directio_test_dev),)
DIO_TEST_DEV = $(shell sed -n -e 's/^[[:space:]]*DIO_TEST_DEV[[:space:]]*=[[:space:]]*\([^[:space:]\#]\+\).*/\1/p' < directio_test_dev)
endif
ifneq ($(DIO_TEST_DEV),)
directio-test_FLAGS := -DDIO_TEST_DEV=\"$(DIO_TEST_DEV)\"
endif

# test-specific linker flags
# XYZ-test_TESTDEPS: test libraries containing __wrap_xyz functions
# XYZ-test_OBJDEPS: object files from libraries to link in explicitly
#    That may be necessary if functions called from the object file are wrapped
#    (wrapping works only for symbols which are undefined after processing a
#    linker input file).
# XYZ-test_LIBDEPS: Additional libs to link for this test

dmevents-test_LIBDEPS = -lpthread -ldevmapper -lurcu
hwtable-test_TESTDEPS := test-lib.o
hwtable-test_OBJDEPS := ../libmultipath/discovery.o ../libmultipath/blacklist.o \
	../libmultipath/structs.o
hwtable-test_LIBDEPS := -ludev -lpthread -ldl
blacklist-test_TESTDEPS := test-log.o
blacklist-test_OBJDEPS := ../libmultipath/blacklist.o
blacklist-test_LIBDEPS := -ludev
vpd-test_OBJDEPS :=  ../libmultipath/discovery.o
vpd-test_LIBDEPS := -ludev -lpthread -ldl
alias-test_TESTDEPS := test-log.o
alias-test_LIBDEPS := -lpthread -ldl
valid-test_OBJDEPS := ../libmultipath/valid.o
valid-test_LIBDEPS := -ludev -lpthread -ldl
devt-test_LIBDEPS := -ludev
ifneq ($(DIO_TEST_DEV),)
directio-test_LIBDEPS := -laio
endif

%.o: %.c
	$(CC) $(CFLAGS) $($*-test_FLAGS) -c -o $@ $<

lib/libchecktur.so:
	mkdir -p lib
	ln ../libmultipath/*/*.so lib

%.out:	%-test lib/libchecktur.so
	@echo == running $< ==
	@LD_LIBRARY_PATH=$(multipathdir):$(mpathcmddir) ./$< >$@

%.vgr:  %-test lib/libchecktur.so
	@echo == running valgrind for $< ==
	@LD_LIBRARY_PATH=$(multipathdir):$(mpathcmddir) \
		valgrind --leak-check=full --error-exitcode=128 ./$< >$@ 2>&1

OBJS = $(TESTS:%=%.o) $(HELPERS)

test_clean:
	$(RM) $(TESTS:%=%.out) $(TESTS:%=%.vgr)

valgrind_clean:
	$(RM) $(TESTS:%=%.vgr)

clean: test_clean valgrind_clean dep_clean
	$(RM) $(TESTS:%=%-test) $(OBJS) *.o.wrap
	$(RM) -rf lib

.SECONDARY: $(OBJS)

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(RM) $(OBJS:.o=.d)

%.o.wrap:	%.c
	@sed -n 's/^.*__wrap_\([a-zA-Z0-9_]*\).*$$/-Wl,--wrap=\1/p' $< | \
		sort -u | tr '\n' ' ' >$@


# COLON will get expanded during second expansion below
COLON:=:
.SECONDEXPANSION:
%-test:	%.o %.o.wrap $$($$@_OBJDEPS) $$($$@_TESTDEPS) $$($$@_TESTDEPS$$(COLON).o=.o.wrap) \
		$(multipathdir)/libmultipath.so Makefile
	$(CC) $(CFLAGS) -o $@ $(LDFLAGS) $< $($@_TESTDEPS) $($@_OBJDEPS) \
		$(LIBDEPS) $($@_LIBDEPS) \
		$(shell cat $<.wrap) $(foreach dep,$($@_TESTDEPS),$(shell cat $(dep).wrap))

=== libmultipath/checkers/Makefile ===
--- 
+++ 
@@ -17,10 +17,10 @@
 
 all: $(LIBS)
 
-libcheckdirectio.so: libsg.o directio.o
+libcheckdirectio.so: directio.o
 	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^ -laio
 
-libcheck%.so: libsg.o %.o
+libcheck%.so: %.o
 	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^
 
 install:
@@ -32,7 +32,7 @@
 clean: dep_clean
 	$(RM) core *.a *.o *.gz *.so
 
-OBJS := $(LIBS:libcheck%.so=%.o) libsg.o directio.o
+OBJS := $(LIBS:libcheck%.so=%.o)
 .SECONDARY: $(OBJS)
 
 include $(wildcard $(OBJS:.o=.d))

=== libmultipath/prioritizers/Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 
 all: $(LIBS)
 
-libpriopath_latency.so: path_latency.o  ../checkers/libsg.o
+libpriopath_latency.so: path_latency.o
 	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^ -lm
 
 libprio%.so: %.o

=== debian/changelog ===
multipath-tools (0.8.5-1ubuntu6) hirsute; urgency=medium

  * debian/test/control:
    - use allow-stderr for kpartx-file-loopback, the new gdisks version
      displays warnings on stderr now

 -- Sebastien Bacher <seb128@debian.org>  Thu, 04 Mar 2021 12:20:20 +0100

multipath-tools (0.8.5-1ubuntu5) hirsute; urgency=medium

  * No-change rebuild to drop the udeb package.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Feb 2021 10:35:31 +0100

multipath-tools (0.8.5-1ubuntu4) hirsute; urgency=medium

  * Drop depends on udebs, such that they don't hold up any other udebs in
    the archive, especially kernel udebs. Otherwise unused in Ubuntu.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 08 Feb 2021 13:18:26 +0000

multipath-tools (0.8.5-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - multipath initramfs fixes for booting from multipathed devices:
      - d/initramfs/hooks: also copy wwids file on the installed
        system to ensure all paths come up on boot. (LP 1479929)
      - d/initramfs/hooks: install multipathd and required
        directories.
      - d/initramfs/hooks: copy multipath udev rules to initramfs
      - d/initramfs/hooks: do not copy kpartx rules to initramfs
      - d/initramfs/local-bottom: remember to stop multipathd.
      - d/initramfs/local-premount: wait for udev to settle before
        the call to resolve_device() in local_mount_root(), so the
        by-uuid/ symlinks have a chance to be updated by the
        multipath udev rules (LP 1503286).
      - d/initramfs/local-premount: Run multipath with -B so not to
        assign names nor change /etc/multipath/bindings during
        initramfs (LP 1561103)
      - d/rules: install d/initramfs/local-bottom
      - d/rules: install d/initramfs/local-premount
    - d/control: multipath-udeb: add sg3-udeb Depends
    - patches to multipath source:
      - d/p/kpartx_more_loopback_fixes.patch: fix loopback mounted files
        some more: since we stat() the loopback device node, we can't rely
        on S_ISREG() tests to handle this case, and should look at the
        device itself instead. (LP 1543430)
      - d/p/enable-find-multipaths.patch: re-enable find_multipaths by
        default -- see the removed 'add_find-multipaths.patch' (LP 1463046)
    - Split kpartx initramfs bits into kpartx-boot for dmraid (LP 941874)
      - d/initramfs/kpartx.hook
      - d/kpartx-boot.postinst
      - d/kpartx-boot.postrm
      - d/control: Add kpartx-boot package for dmraid
      - d/rules: Install kpartx initramfs hook
      - d/kpartx.install: install all arch /lib* kpartx udev rules
    - debian/multipath-tools.dm-mpath-lvm.udev: Adjust initramfs integration
      for new udev rules
    - Remove d/initramfs/local-top (redundant with other initramfs scripts):
      - init-top: take over loading modules (dm-multipath and SCSI device
        handlers); move the missing dm-emc there (now scsi-dh-emc; see
        BTS 567014).
      - d/rules: do not install local-top anymore.
      - remove d/initramfs/local-top
    - d/control: Enable udebs on riscv64 to fix FTBFS.
    - d/control, d/rules: i386 related fixes
      - Stop producing udebs on i386 where we no longer have d-i or a kernel.
      - Fix debian/rules to not explode when building without udebs on i386.
      - Don't build the multipath-tools binary package on i386; we only want
        kpartx.
    - Disable -fexceptions on multipath-udeb (LP 1489379): the flag causes
      libchecktur.so to link with libgcc_s.so.1 (even with -static-libgcc),
      which is not available in the installer environment.
      - d/p/disable-fexceptions-udeb.patch: conditionally disable
        -fexceptions with CFLAGS_DISABLE_FEXCEPTIONS.
      - d/rules: set CFLAGS_DISABLE_FEXCEPTIONS to build multipath-udeb.
    - d/p/kpartx-print-loop-deleted-to-stdout-not-stderr.patch: Print loop
      deleted message to stdout again, not stderr; to fix autopkgtest
    - d/multipath.conf: Install friendly names multipath.conf by default,
      instead of generating it in every installer.
    - d/rules: Move udev rules to priority 95, because rules that load
      modules should be >90.
    - d/p/no-start-in-containers.patch: Do not attempt to start
      multipath-tools in containers, should switch for on-demand udev/socket
      based activation in the future. (LP 1823093)
    - d/p/kpartx-Improve-finding-loopback-device-by-file.patch: Improve
      finding loopback devices (LP 1747044)
    - debian/initramfs/hooks: Add dm-queue-length: users may want to
      change from the default selector and should be able to do so.
      (LP 1673350)
    - debian/initramfs/local-bottom: wait for the multipathd unix
      socket to close, so to avoid multipathd.socket unit failure.
      (LP 1682178)
    - debian/tests/tgtbasedmpaths:
      - Add sleep to allow for device creation
      - Use stable wwn-* names in autopkgtest that work with or without
        friendly names, as scsi-${DM_NAME} is not a stable symlink name.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 25 Dec 2020 22:51:36 +0100

multipath-tools (0.8.5-1) unstable; urgency=medium

  [ Ritesh Raj Sarraf ]
  * [9e88f52] Add README.alua to docs section

  [ Christian Ehrhardt ]
  * [7860503] d/t/tgtbasedmpaths: reduce memory pressure avoiding OOM
    triggered false positives

  [ Chris Hofstaedtler ]
  * [859ade1] Update upstream git (and our debian/watch) URL
  * [bdc291a] New upstream version 0.8.5
  * [83060d2] Rebase patches
  * [cb467ba] multipath.rules: Avoid usrmerge paths (Closes: #973853)
  * [61df246] kpartx: update package description (Closes: #690995)
  * [3262269] Drop 0001-Blacklist-cciss-devices.patch.
    Upstream has switched to an exclusive list of devices by default.
    Only sd, dasd and nvme devices are seen by multipath now. This makes
    the cciss exclusion obsolete.
  * [602298a] Follow README.md rename
  * [2018daf] Remove obsolete override for lintian tag


=== debian/control ===
--- 
+++ 
@@ -26,7 +26,10 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}, udev, dmsetup
 Description: create device mappings for partitions
  Kpartx can be used to set up device mappings for the partitions of any
- partitioned block device. It is part of the Linux multipath-tools.
+ partitioned block device.
+ .
+ It is part of the Linux multipath-tools, but is useful on any
+ device-mapper using system.
 
 Package: kpartx-boot
 Architecture: all
@@ -53,7 +56,6 @@
 Package: multipath-udeb
 Package-Type: udeb
 Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
-Depends: ${shlibs:Depends}, ${misc:Depends}, multipath-modules, kpartx-udeb, sg3-udeb
 Section: debian-installer
 Description: maintain multipath block device access - udeb package
  This is a udeb, or a microdeb, for the debian-installer.
@@ -64,7 +66,6 @@
 Package: kpartx-udeb
 Package-Type: udeb
 Architecture: amd64 arm64 armhf ppc64el riscv64 s390x
-Depends: ${shlibs:Depends}, ${misc:Depends}
 Section: debian-installer
 Description: create device mappings for partitions - udeb package
  This is a udeb, or a microdeb, for the debian-installer.

=== debian/rules ===
--- 
+++ 
@@ -1,12 +1,6 @@
 #!/usr/bin/make -f
 
 INITRAMFS=$(CURDIR)/debian/multipath-tools-boot/usr/share/initramfs-tools/
-
-ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
-        INSTALL_PROGRAM = install -s
-else
-        INSTALL_PROGRAM = install
-endif
 
 ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH),i386)
         ADD_UDEB = --no-add-udeb
@@ -39,11 +33,10 @@
 	[ ! -f kpartx/del-part-nodes.rules ] || cp kpartx/del-part-nodes.rules debian/kpartx.del-part-nodes.udev
 	[ ! -f kpartx/dm-parts.rules ] || cp kpartx/dm-parts.rules debian/kpartx.dm-parts.udev
 	[ ! -f kpartx/kpartx.rules ] || cp kpartx/kpartx.rules debian/kpartx.udev
+	[ ! -f multipath/multipath.rules ] || cp multipath/multipath.rules debian/multipath.udev
 	[ ! -f multipath/11-dm-mpath.rules ] || cp multipath/11-dm-mpath.rules debian/dm-mpath.udev
 
-	dh_auto_build -- $(OPTFLAGS) LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1
-
-	[ ! -f multipath/multipath.rules ] || cp multipath/multipath.rules debian/multipath.udev
+	dh_auto_build --parallel -- $(OPTFLAGS) LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1
 
 	touch $@
 
@@ -51,11 +44,11 @@
 build-multipath-udeb-stamp:
 	dh_testdir
 
-	DEB_CFLAGS_MAINT_APPEND="-static-libgcc" CFLAGS_DISABLE_FEXCEPTIONS=1 dh_auto_build -- $(OPTFLAGS) LIB=/lib USE_SYSTEMD=0
+	DEB_CFLAGS_MAINT_APPEND="-static-libgcc" CFLAGS_DISABLE_FEXCEPTIONS=1 dh_auto_build --parallel -- $(OPTFLAGS) LIB=/lib USE_SYSTEMD=0
 	
 	# store files for install target
 	mkdir -p $(CURDIR)/debian/tmp-multipath-udeb/sbin
-	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp-multipath-udeb LIB=/lib USE_SYSTEMD=0
+	$(MAKE) -j1 install DESTDIR=$(CURDIR)/debian/tmp-multipath-udeb LIB=/lib USE_SYSTEMD=0
 
 	touch $@
 
@@ -103,7 +96,7 @@
 	dh_installdirs
 
 	mkdir -p $(CURDIR)/debian/tmp/sbin
-	$(MAKE) install INSTALL_PROGRAM=$(INSTALL_PROGRAM) DESTDIR=$(CURDIR)/debian/tmp LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1
+	$(MAKE) -j1 install DESTDIR=$(CURDIR)/debian/tmp LIB=/lib SYSTEMDPATH=/lib USE_SYSTEMD=1
 	install -m 755 debian/dmsetup_env $(CURDIR)/debian/tmp/lib/udev/
 	mkdir -p $(CURDIR)/debian/tmp/etc
 	cp debian/multipath.conf $(CURDIR)/debian/tmp/etc
@@ -117,6 +110,8 @@
 	dh_installchangelogs -i
 	dh_installdocs -i
 	dh_installexamples -i
+	dh_installinit -pmultipath-tools-boot --name=multipath-tools-boot --no-start -- start 21 S .
+	dh_installinit -pmultipath-tools-boot
 	dh_installdebconf -pmultipath-tools-boot
 	dh_installman -i
 	dh_compress -i
@@ -135,6 +130,7 @@
 	dh_installexamples -a
 	dh_lintian -a
 	dh_systemd_enable -pmultipath-tools multipathd.service
+	dh_installinit -pmultipath-tools
 	dh_installudev -pkpartx --priority=95
 	dh_installudev -pkpartx --name=dm-parts --priority=56
 	dh_installudev -pkpartx --name=del-part-nodes --priority=68
@@ -156,4 +152,7 @@
 	dh_builddeb -a $(skip_packages)
 
 binary:	binary-indep binary-arch
-.PHONY: binary binary-arch binary-indep unpack configure build clean 
+.PHONY: binary binary-arch binary-indep unpack configure build clean
+
+# We build the same tree twice, this cannot happen in parallel.
+.NOTPARALLEL:

=== debian/tests/control ===

Tests: kpartx-file-loopback
Depends: kpartx, qemu-utils, gdisk
Restrictions: needs-root, isolation-machine, allow-stderr

Tests: tgtbasedmpaths
Depends: multipath-tools, tgt, open-iscsi, fio, lsscsi
Restrictions: needs-root, isolation-machine, allow-stderr
